define DEFINE_RULES

CC_INVOKE_$(1) = $$(CC) $$(CCFLAGS_$(1)) $$(CFLAGS_$$(CURRENT_MODULE)) $$(CCFLAGS_$$(CURRENT_MODULE)) $$(CFLAGS_$$(CURRENT_MODULE)_$(1)) $$(CCFLAGS_$$(CURRENT_MODULE)_$(1)) -DCURRENT_MODULE=$$(CURRENT_MODULE)
CXX_INVOKE_$(1) = $$(CXX) $$(CXXFLAGS_$(1)) $$(CFLAGS_$$(CURRENT_MODULE)) $$(CXXFLAGS_$$(CURRENT_MODULE)) $$(CFLAGS_$$(CURRENT_MODULE)_$(1)) $$(CXXFLAGS_$$(CURRENT_MODULE)_$(1)) -DCURRENT_MODULE=$$(CURRENT_MODULE)

$$(BUILD_PATH)/obj/$(1)/%.m.o: %.m
	$$(AUTO_MKDIR)
	$$(CC_INVOKE_$(1)) -fobjc-arc -c -o $$@ $$<

$$(BUILD_PATH)/obj/$(1)/%.cpp.o: %.cpp
	$$(AUTO_MKDIR)
	$$(CXX_INVOKE_$(1)) -c -o $$@ $$<

$$(BUILD_PATH)/obj/$(1)/%.c.o: %.c
	$$(AUTO_MKDIR)
	$$(CC_INVOKE_$(1)) -c -o $$@ $$<

$$(BUILD_PATH)/obj/$(1)/%.cpp.dep: %.cpp
	$$(AUTO_MKDIR)
	@$$(CXX_INVOKE_$(1)) -Wno-#warnings -MT $$(@:.dep=.o) -M $$^ -o $$@

$$(BUILD_PATH)/obj/$(1)/%.dep: %
	$$(AUTO_MKDIR)
	@$$(CC_INVOKE_$(1)) -Wno-#warnings -MT $$(@:.dep=.o) -M $$^ -o $$@

$$(TARGET_$(1)):
	$$(AUTO_MKDIR)
	$$(LD) $$(LDFLAGS_$(1)) $$^ -o $$@

endef

$(foreach i,$(PLATFORMS),$(eval $(call DEFINE_RULES,$(i))))