define HANDLE_PLATFORM

OBJECTS_$(1) += $$(addsuffix .o,$$(addprefix $(BUILD_PATH)/obj/$(1)/,$$(call FILTER_OUT,$$(SOURCE_FILTER_$(1)), $$(SOURCES))))

$$(TARGET_$(1)): $$(OBJECTS_$(1))

$(1): $$(TARGET_$(1))

ifeq ($(USE_AUTO_DEPS),true)
-include $$(patsubst %.o,%.dep,$$(OBJECTS_$(1)))
endif

endef

SOURCES := $(shell find * -type f -name "*.c" -o -name "*.cpp" -o -name "*.m")

-include $(addsuffix module.mk,$(shell echo */))

$(foreach i,$(PLATFORMS),$(eval $(call HANDLE_PLATFORM,$(i))))
